#include "LoaderActivity.h"
#include "globals.h"
#include "Helpers.h"
#include "Logs.h"

void LoaderActivity::begin()
{
    if (!g_btnMinus.read() || !g_btnPlus.read())
    {
        load();
    }
    else
    {
        BaseActivity::begin();
    }
}

void LoaderActivity::load()
{
    LOG(1, "%s: Loading settings", __FUNCTION__);
    g_storage.load();
    g_appCore.setActivity(&g_homeActivity);
}

void LoaderActivity::reset()
{
    LOG(1, "%s: Resetting settings", __FUNCTION__);
    g_storage.save();
    g_appCore.setActivity(&g_homeActivity);
}

void LoaderActivity::getLcdText(char** lines)
{
    Helpers::center(lines[0], "Reset?", 16, ' ');
}

void LoaderActivity::onButtonReleased(BaseActivity::Button button)
{
    if (button == Cancel)
    {
        load();
    }
    else if (button == Ok)
    {
        reset();
    }
}
